# Ceb trace format:
#    PC instruction | anytext
# PC and instruction are in hex.  anytext is 
#       cycle  "disasm inst"
# in cebollita.
# Here it's 
#       virtual-cycle  real-cycle
# where virtual-cycle counts only non-stall cycles.

sub usage
{
    print "Usage: perl trchk.pl traceFile0\n",
          "\tConverts the trace file created by a 3-input SMOK\n",
          "Trace component to Cebollita format.\n";
    exit 1;
}

sub readcycle
{
    my $cycledata = {
		     cycle => -1,
		     pc => -1,
		     inst => -1,
		     stall => 0,
		     };

    local (*HANDLE) = @_;
    while ( <HANDLE> ) {
	my ($cycle, $code, $val) = split;
        last if $code == -1;
	$cycledata->{"cycle"} = $cycle;
	$cycledata->{"pc"} = $val if $code == 0;
	$cycledata->{"inst"} = $val if $code == 1;
	$cycledata->{"stall"} = $val if $code == 2;
    }
    return $cycledata;
}


usage() if $#ARGV != 0;

open( INFILE, "< $ARGV[0]" ) || die "Couldn't open $ARGV[0]: $!";

my $firstData;
my $cycle = 0;
for (my $cycle=0; ; $cycle++ ) {
    # eliminate stalls
    do {
	$firstdata = readcycle( *INFILE );
    } while ( $firstdata->{"stall"} != 0 and $firstdata->{"cycle"} != -1 );
    last if $firstdata->{"cycle"} == -1;

    my $hexinst = sprintf "%08x", $firstdata->{"inst"};
    #my $instStr = `java util.Disasm $hexinst`;
    #chomp $instStr;
    #printf "%08x  $hexinst  | %d \"$instStr\"\n", $firstdata->{"pc"}, $firstdata->{"cycle"};
    printf "%08x  $hexinst  | %9d %9d\n", $firstdata->{"pc"}, $cycle, $firstdata->{"cycle"};
}
