# Invokes diff on two trace files, after first stripping off the comments
# (anything following the '|' character).

sub usage
{
    print "Usage: perl diffTrace.pl traceFile0 tracefile1\n",
          "\tEach trace file must be either a Cebollita produced trace\n",
          "\tor else have come from SMOK and been processed by convertTrace.pl\n";
    exit 1;
}

# takes actual- filename new-filename
sub processFile
{
    my $realfile = @_[0];
    my $newfile = `basename $realfile`;
    chomp $newfile;
    $newfile = ".$newfile-fordiff";
    open(INFILE, "< $realfile") || die "Couldn't open $realfile: $!";
    open(OUTFILE, "> $newfile") || die "Couldn't open $newfile: $!";

    while ( <INFILE> ) {
	s/ *\|.*$//;
        print OUTFILE "$_";
    }
    close INFILE;
    close OUTFILE;

    return $newfile;
}


usage() if $#ARGV != 1;
my $firstFile = processFile( $ARGV[0] );
my $secondFile = processFile( $ARGV[1] );

print "$firstFile $secondFile";
